/*
 * Copyright (c) 2003-2021
 * Distributed Systems Software.  All rights reserved.
 * See the file LICENSE for redistribution information.
 *
 * $Id: dacs_qsort.h 3200 2022-01-01 21:24:59Z brachman $
 */

#ifndef _DACS_QSORT_H_
#define _DACS_QSORT_H_

#ifdef __cplusplus
extern "C" {
#endif

/*
 * The order of the last two arguments of qsort_r() is reversed in the BSD
 * implementation vs. glibc.  The ordering of the comparison callback
 * function parameters is also different.
 * See dacs_qsort.c
 */
extern void bsd_qsort_r(void *base, size_t nmemb, size_t size, void *thunk,
						int (*compar)(void *argptr, const void *a,
									  const void *b));

typedef int (*merge_cmp_t)(const void *, const void *);

extern int bsd_mergesort(void *, size_t, size_t, merge_cmp_t);
#ifdef NOTDEF
/* XXX Not built. */
extern int bsd_mergesort_b(void *, size_t, size_t, merge_cmp_t);
#endif

#ifdef __cplusplus
}
#endif

#endif
