[4mDACS.VFS[24m(5)                   DACS Formats Manual                  [4mDACS.VFS[24m(5)

[1mNAME dacs.vfs - the DACS [22mvirtual filestore

[1mDESCRIPTION[0m

       These files are part of the [1mDACS [22msuite.

       The virtual filestore provides flexible ways for [1mDACS [22mand software
       built on top of [1mDACS [22mto obtain information regardless of how or where
       the information is stored. The [1mDACS [22mcore accesses (almost) all
       configuration information through the virtual filestore layer, allowing
       information to be more easily shared and maintained, secured, or
       organized for better performance.

       Sometimes it is easiest to store information in a regular file
       initially, where it can be modified using an ordinary text editor, but
       after some growth a database might improve performance. In some
       situations, accessing the information remotely, via HTTP, makes
       administration more convenient or is more secure. A goal of the virtual
       filestore is to make data storage alternatives easier to specify and
       change.

   [1mThe vfs_uri and Item Types[0m

       Many [1mDACS [22mcomponents need to access data to perform their function. The
       documentation for a component will specify a reserved, case-sensitive
       name called an item type for each data set that it may use. For
       example, [34m[1mdacspasswd(1)[0m[1m[22m[1] identifies the account information that it
       manages by the name passwds.

       Item types start with an alphabetic character followed by zero or more
       alphanumerics, hyphens, and underscores. Item types used by [1mDACS [22mare
       always completely lower case. Some other item types used by [1mDACS [22mare
       federation_keys and jurisdiction_keys (used by [34m[1mdacskey(1)[0m[1m[22m[2] and
       others), and revocations (used by [34m[1mdacs.acls(5)[0m[1m[22m[3] and others). The
       [34m[1mdacsconf(1)[0m[1m[22m[4] command can list all reserved item types.

       The [34m[1mVFS[0m[1m[22m[5] directive is used to specify the mapping from an item type
       to a vfs_uri, which describes where and how the information is stored.
       Some commands and functions take a vfs_uri as an argument to provide a
       default or override a default. A vfs_uri has the following syntax:

           vfs_uri -> [ ´[´ [4mitem_type[24m ´]´ ] [4mURI[0m

       The general form of the URI syntax is (see [34m[1mRFC 2396[0m[1m[22m[6] and [34m[1mRFC[0m
       [1m[34m3986[0m[1m[22m[7]):

           [4mscheme[24m : [ // [4mauthority[24m] [[4mpath[24m] [[4mquery[24m] [[4mfragment[24m]

       The distribution´s conf/site.conf-std file (by default installed as
       /usr/local/dacs/federations/site.conf; see [34m[1mdacs.install(7)[0m[1m[22m[8])
       specifies defaults for many item types. For example, it defines the
       "roles file" (item type roles; see [34m[1mdacs_authenticate(8)[0m[1m[22m[9]) as:

           VFS "[roles]dacs-kwv-fs:${Conf::FEDERATIONS_ROOT}/${Conf::FEDERATION_DOMAIN}/${Conf::JURISDICTION_NAME}/roles"

       For the hypothetical federation domain example.com and jurisdiction J1,
       by default this would resolve to a file,
       /usr/local/dacs/federations/example.com/J1/roles. That file might
       consist of entries like:

           julia:project1/dacs,admin,horses
           sara:project2/dacs,project1/dacs,lps
           sam:project2/dacs,project1/dacs
           admin:root,project2/admin

       The default location of the [1mDACS [22mXML DTDs (item type dtds) is defined
       as:

           VFS "[dtds]dacs-fs:${Conf::DACS_HOME}/www/dtd-xsd"

       By default, this would resolve to the directory
       /usr/local/dacs/www/dtd-xsd.

       Refer to the [34m[1mVFS[0m[1m[22m[5] directive for additional detail.

   [1mVirtual Filestore Details[0m

       Each virtual filestore instance contains either an uninterpreted
       sequence of bytes (e.g., a Unix file or the output of a program) or an
       object that contains zero or more items, each of which is associated
       with a key (i.e., the name of an item relative in its virtual filestore
       context) and has an uninterpreted sequence of bytes as its value (e.g.,
       a database file, a Unix file containing lines having a particular
       keyword/value structure, or a directory containing regular files).

       For maximum portability, a key should be composed of characters from
       the [34m[1mPortable Filename Character Set[0m[1m[22m[10]: any alphanumeric character,
       period, hyphen, or underscore. The true limitation on the character set
       depends on the underlying storage scheme and URI syntax constraints.
       There is no [4ma[24m [4mpriori[24m limit on naming context or key length.

[1mSEE ALSO[0m

       [34m[1mdacsvfs(1)[0m[1m[22m[11], [34m[1mdacs.conf(5)[0m[1m[22m[12], [34m[1mdacs.install(7)[0m[1m[22m[8], [34m[1mdacs_vfs(8)[0m[1m[22m[13]

[1mAUTHOR[0m

       Distributed Systems Software ([34m[1mwww.dss.ca[0m[1m[22m[14])

[1mCOPYING[0m

       Copyright © 2003-2018 Distributed Systems Software. See the [34m[1mLICENSE[0m[1m[22m[15]
       file that accompanies the distribution for licensing information.

[1mNOTES[0m

        1. dacspasswd(1)
           http://dacs.dss.ca/man/dacspasswd.1.html

        2. dacskey(1)
           http://dacs.dss.ca/man/dacskey.1.html

        3. dacs.acls(5)
           http://dacs.dss.ca/man/dacs.acls.5.html

        4. dacsconf(1)
           http://dacs.dss.ca/man/dacsconf.1.html

        5. VFS
           http://dacs.dss.ca/man/dacs.conf.5.html#VFS

        6. RFC 2396
           https://www.rfc‐editor.org/rfc/rfc2396.txt

        7. RFC 3986
           https://www.rfc‐editor.org/rfc/rfc3986.txt

        8. dacs.install(7)
           http://dacs.dss.ca/man/dacs.install.7.html

        9. dacs_authenticate(8)
           http://dacs.dss.ca/man/dacs_authenticate.8.html#local_roles

       10. Portable Filename Character Set
           https://www.opengroup.org/onlinepubs/009695399/basedefs/xbd_chap03.html#tag_03_276

       11. dacsvfs(1)
           http://dacs.dss.ca/man/dacsvfs.1.html

       12. dacs.conf(5)
           http://dacs.dss.ca/man/dacs.conf.5.html

       13. dacs_vfs(8)
           http://dacs.dss.ca/man/dacs_vfs.8.html

       14. www.dss.ca
           https://www.dss.ca

       15. LICENSE
           http://dacs.dss.ca/man/../misc/LICENSE

DACS 1.5.0                        04/09/2025                       [4mDACS.VFS[24m(5)
