[4mDACS_PASSWD[24m(8)             DACS Web Services Manual             [4mDACS_PASSWD[24m(8)

[1mNAME dacs_passwd - manage private DACS [22mpasswords

[1mSYNOPSIS[0m

       [1mdacs_passwd [22m[[34m[1mdacsoptions[0m[1m[22m[1]]

[1mDESCRIPTION[0m

       This program is part of the [1mDACS [22msuite.

       The [1mdacs_passwd [22mweb service is used to manage usernames and passwords
       recognized by [34m[1mlocal_passwd_authenticate[0m[1m[22m[2], a [1mDACS [22mauthentication
       module. This utility serves a similar purpose for
       [1mlocal_passwd_authenticate [22mthat [1mApache[22m´s [34m[1mhtpasswd(1)[0m[1m[22m[3] command does for
       its [34m[1mmod_authn_file[0m[1m[22m[4] and [34m[1mmod_authn_dbm[0m[1m[22m[5] modules. These accounts and
       passwords are used only by [1mlocal_passwd_authenticate [22mand are completely
       separate from any other accounts and passwords.

           [1mNote[0m

           Much of the functionality of this program is also available as a
           [1mDACS [22mutility, [34m[1mdacspasswd(1)[0m[1m[22m[6], which operates on the same password
           files. Because [34m[1mdacs_admin(8)[0m[1m[22m[7] provides the same functionality and
           more, [1mdacs_passwd [22mmay be removed in a future release.

           [1mSecurity[0m

           This web service enforces several requirements over and above those
           specified by its access control rule. The [4mUSERNAME[24m argument must be
           syntactically valid and lowercase. The user must already be
           authenticated. To change his password, a (non-admin) user must
           enter his current password.

           The default [1mDACS [22mACL restricts use of this web service to a [1mDACS[0m
           administrator and to users who are setting the password for their
           own [1mDACS [22maccount at the receiving jurisdiction. Administrators
           should ensure that the ACL for [1mdacs_passwd [22mis correct for their
           environment.

[1mOPTIONS[0m

   [1mWeb Service Arguments[0m

       In addition to the [34m[1mstandard CGI arguments[0m[1m[22m[8], [1mdacs_passwd [22munderstands
       the following CGI arguments:

       [4mOPERATION[0m
           The following operations are supported:

           •   [4mADD[0m

               Like [4mSET[24m but add or replace an entry for [4mUSERNAME[24m.

           •   [4mDELETE[0m

               Delete the account for [4mUSERNAME[24m.

           •   [4mDISABLE[0m

               Disable the account for [4mUSERNAME[24m.

           •   [4mENABLE[0m

               Enable the account for [4mUSERNAME[24m.

           •   [4mLIST[0m

               List [4mUSERNAME[24m, if it exists, otherwise all usernames. A
               disabled account is indicated by a ´*´ (which is not a valid
               character in a username).

           •   [4mSET[0m

               Sets or resets a [1mDACS [22mpassword for [4mUSERNAME[24m to [4mNEW_PASSWORD[24m.
               The [4mCONFIRM_NEW_PASSWORD[24m argument must also be given and be
               identical to [4mNEW_PASSWORD[24m. Unless the operation is performed by
               a [1mDACS [22madministrator (i.e., an [34m[1mADMIN_IDENTITY[0m[1m[22m[9]) or disabled
               by the [34m[1mPASSWORD_OPS_NEED_PASSWORD[0m[1m[22m[10] directive, the current
               password for [4mUSERNAME[24m must be given as [4mPASSWORD[24m.

                   [1mSecurity[0m
                   For users other than a [1mDACS [22madministrator, a password must
                   meet certain requirements on its length and the character
                   set from which it is comprised. Note that these
                   requirements are only significant at the time a password is
                   set or changed; existing passwords are unaffected by
                   changes to the configuration directives. Please refer to
                   the [34m[1mPASSWORD_CONSTRAINTS[0m[1m[22m[11] directive.

                   Users should be made aware of security issues related to
                   passwords, including better techniques for selecting
                   passwords and keeping them private.

                   The National Institute of Standards and Technology (NIST)
                   recommends (in [34m[1mNIST Special Publication 800-63b[0m[1m[22m[12] and
                   [34m[1melsewhere[0m[1m[22m[13]):

                   •   Because password length is much more important than
                       password complexity, use passwords or passphrases of 15
                       or more characters (without specific requirements for
                       character case or special characters);

                   •   Require password changes only when there is reason to
                       believe they may have been compromised;

                   •   Screen passwords against lists of dictionary words and
                       passwords known to have been compromised;

                   •   Do not provide password hints.


                       Creating a memorable (non-random) sentence of between 5
                       and 10 words [34m[1mhas also been argued[0m[1m[22m[14].

                       [1mChoosing better passwords[0m
                       While formulating a strong password is important, most
                       people have multiple accounts and each should have a
                       different password. This can be handled by creating
                       passwords using a method similar to the one described
                       in [34m[1mthis proposal[0m[1m[22m[15]. Basically, each password is
                       [4msite-specific[24m and formed from three separate
                       components:

                        1. [4mPIN-1[24m, a short, [4mrandom[24m string that is common to all
                           of the user´s passwords, [4mkept[24m [4msecret[24m, and unlikely
                           to be in any dictionary;

                        2. [4mSITE[24m, a string that is derived from a site´s name
                           (or domain name) using some simple and
                           easy-to-remember procedure (e.g., using an obvious
                           abbreviation or prefix, or the first four letters
                           or consonants, perhaps mixing upper and lower
                           case); and

                        3. [4mPIN-2[24m, a short, site-specific [4mrandom[24m string that is
                           different for each of the user´s passwords, and
                           unlikely to be in any dictionary.

                           [4mPIN-1[24m is memorized by the user and never written
                           down (except, perhaps, if kept in a safety deposit
                           box or other highly secure location). The other two
                           components may be written down but must be kept in
                           a relatively secure location (such as in the user´s
                           wallet or in a locked desk drawer).

                           The user forms passwords by combining these three
                           components in any order that is easy to remember,
                           like:

                               [4mSITE[24m [4mPIN-2[24m [4mPIN-1[0m

                           Following that ordering, for the site
                           www.example.net, a user might select the password
                           "exampleRB8s#i8", where "example" (component 2,
                           [4mSITE[24m) is derived from the site´s domain name,
                           "RB8s" is a random string used with this password
                           only (component 3, [4mPIN-2[24m), and "#i8" is the user´s
                           secret PIN (component 1, [4mPIN-1[24m). Because it is
                           probably difficult to remember, the user might
                           record "www.example.net RB8s" but [4mnot[24m [4mPIN-1[24m.

                           For httpd.apache.org, the same user might select
                           the password "httpd33ABB#i8".

                           For the site dacs.dss.ca, the user might select the
                           password "dacsceIM#i8".

                           Because the characters comprising [4mPIN-1[24m must be
                           acceptable to all of the sites where a user has an
                           account, and some sites accept a rather limited
                           character set for their passwords, it may be
                           necessary to restrict [4mPIN-1[24m to the alphanumeric
                           alphabet. The other two components can be chosen
                           from whatever password characters are permitted by
                           the particular site. As some sites unfortunately
                           allow only relatively short passwords, it is
                           preferable to shorten [4mSITE[24m rather than either of
                           the other two components.

                           Provided the basic rules are followed, a user can
                           strengthen the method by making minor changes to
                           the typed password as the three components are
                           combined. As a simple example, one or more
                           separating characters, also from a restricted
                           character set so that it will be widely accepted,
                           might be added before and after the middle
                           component:

                               [4mSITE[24m Z [4mPIN-2[24m Z [4mPIN-1[0m

                           In this example, a ´Z´ is used as a separating
                           character. This alteration is memorized, not
                           recorded.

                           More generally, a user might make character
                           substitutions, insertions, or deletions that are
                           easy to remember and perform mentally as the three
                           components are combined and typed. For example, all
                           digits in [4mPIN-2[24m might be recorded with one added to
                           them (modulo ten), or every third written character
                           might be discarded. Applying these changes to the
                           recorded components makes them less useful to
                           anyone else that might read them.

                           Since most people are not very good at it, the
                           random strings should be chosen using a
                           good-quality random generator, such as the
                           [34m[1mrandom()[0m[1m[22m[16] function:

                               % dacsexpr -e "random(string, 4, ´a-zA-Z0-9,./;@#´)"
                               "y2FJ"

                           Or, on FreeBSD or macOS:

                               % jot -r -c 20 33 126 | rs -g 0 4
                               ib2Y
                               25$z
                               vI9Z
                               ˆKpZ
                               51b7

                           The main disadvantage of the method is that if the
                           "little black book" of password components is
                           needed at more than one location it must either be
                           carried or duplicated (with the copies
                           synchronized). In practice, users will remember
                           frequently used passwords and not need to consult
                           the written components. Still, losing the written
                           material could be painful, but passwords can
                           usually be reset and a secondary copy could be kept
                           at a safe, alternate location.

                           To summarize, these passwords:

                           •   are more difficult to guess because of their
                               random components and reasonably large
                               character set;

                           •    are different for each site.  Should one
                               password be compromised, the others are not
                               immediately available to an attacker;

                           •    cannot be immediately exploited if the written
                               list is stolen or copied;

                           •    can be made stronger and safer by making
                               either or both PIN components longer, chosen
                               from a larger space of characters, or by
                               inserting one or more characters between
                               components, or by performing some simple mental
                               transformations on written components.

                               Software is available to help evaluate password
                               strength (e.g., [34m[1mHow Big is Your Haystack?[0m[1m[22m[17]),
                               but avoid giving out an actual password you
                               intend to use.

                       [4mACCOUNT[0m
                           Either PASSWD (the default) or SIMPLE, case
                           insensitively, to select between the item types
                           passwds and simple, respectively. The requested
                           item type must be configured (see
                           [34m[1mdacs.conf(5)[0m[1m[22m[18]).

                       [4mUSERNAME[0m
                           The [1mDACS [22musername of interest.

                       [4mFORMAT[0m
                           By default, output is emitted in HTML. Several
                           varieties of XML output can be selected, however,
                           using the [4mFORMAT[24m argument (please refer to
                           [34m[1mdacs(1)[0m[1m[22m[19] and [34m[1mdacs_passwd.dtd[0m[1m[22m[20]).

[1mDIAGNOSTICS[0m

                       The program exits 0 if everything was fine, 1 if an
                       error occurred.

[1mSEE ALSO[0m

                       [34m[1mdacspasswd(1)[0m[1m[22m[6], [34m[1mdacs_admin(8)[0m[1m[22m[7], [34m[1mdacs.conf(5)[0m[1m[22m[21]

                       For recommendations on best practices for password
                       selection and password verification, see Section 5 of
                       [34m[1mNIST Special Publication 800-63B[0m[1m[22m[22], [4mDigital[24m [4mIdentity[0m
                       [4mGuidelines:[24m [4mAuthentication[24m [4mand[24m [4mLifecycle[24m [4mManagement[24m,
                       June 2017, updated to March 2020.

[1mAUTHOR[0m

                       Distributed Systems Software ([34m[1mwww.dss.ca[0m[1m[22m[23])




[1mCOPYING[0m

                       Copyright © 2003-2025 Distributed Systems Software. See
                       the [34m[1mLICENSE[0m[1m[22m[24] file that accompanies the distribution
                       for licensing information.




[1mNOTES[0m

                        1.
                           dacsoptions
                           http://dacs.dss.ca/man/dacs.1.html#dacsoptions

                        2. local_passwd_authenticate
                           http://dacs.dss.ca/man/dacs_authenticate.8.html#local_passwd_authenticate

                        3. htpasswd(1)
                           https://httpd.apache.org/docs/2.4/programs/htpasswd.html

                        4. mod_authn_file
                           https://httpd.apache.org/docs/2.4/mod/mod_authn_file.html

                        5. mod_authn_dbm
                           https://httpd.apache.org/docs/2.4/mod/mod_authn_dbm.html

                        6. dacspasswd(1)
                           http://dacs.dss.ca/man/dacspasswd.1.html

                        7. dacs_admin(8)
                           http://dacs.dss.ca/man/dacs_admin.8.html

                        8. standard CGI arguments
                           http://dacs.dss.ca/man/dacs.services.8.html#standard_cgi_args

                        9. ADMIN_IDENTITY
                           http://dacs.dss.ca/man/dacs.conf.5.html#ADMIN_IDENTITY

                       10. PASSWORD_OPS_NEED_PASSWORD
                           http://dacs.dss.ca/man/dacs.conf.5.html#PASSWORD_OPS_NEED_PASSWORD

                       11. PASSWORD_CONSTRAINTS
                           http://dacs.dss.ca/man/dacs.conf.5.html#PASSWORD_CONSTRAINTS

                       12. NIST Special Publication 800‐63b
                           https://pages.nist.gov/800‐63‐3/sp800‐63‐3.html

                       13. elsewhere
                           https://www.us‐cert.gov/ncas/tips/ST04‐002

                       14. has also been argued
                           https://arxiv.org/abs/1505.05090

                       15. this proposal
                           https://www.f‐secure.com/weblog/archives/00001691.html

                       16. random()
                           http://dacs.dss.ca/man/dacs.exprs.5.html#random

                       17. How Big is Your Haystack?
                           https://www.grc.com/haystack.htm

                       18. dacs.conf(5)
                           http://dacs.dss.ca/man/dacs.conf.5.html#VFS

                       19. dacs(1)
                           http://dacs.dss.ca/man/dacs.1.html

                       20. dacs_passwd.dtd
                           http://dacs.dss.ca/man/../dtd‐xsd/dacs_passwd.dtd

                       21. dacs.conf(5)
                           http://dacs.dss.ca/man/dacs.conf.5.html

                       22. NIST Special Publication 800‐63B
                           https://csrc.nist.gov/publications/detail/sp/800‐63b/final

                       23. www.dss.ca
                           https://www.dss.ca

                       24. LICENSE
                           http://dacs.dss.ca/man/../misc/LICENSE

DACS 1.5.0                        04/09/2025                    [4mDACS_PASSWD[24m(8)
