[4mDACS_STS[24m(8)                DACS Web Services Manual                [4mDACS_STS[24m(8)

[1mNAME dacs_sts - Secure Token Service for managed Information Cards[0m

[1mSYNOPSIS[0m

       [1mdacs_sts [22m[[34m[1mdacsoptions[0m[1m[22m[1]]

[1mDESCRIPTION[0m

       This program is part of the [1mDACS [22msuite.

       The [1mdacs_sts [22mweb service is the Secure Token Service for [1mDACS´s [22mmanaged
       Information Cards.

       Refer to [34m[1mdacs_managed_infocard(8)[0m[1m[22m[2] for additional information.

           [1mSecurity[0m

           Depending on the application, consider adding a custom access
           control rule for [1mdacs_sts [22m(e.g., to limit access to a particular
           host or subnet, or even certain identities).

   [1mConfiguration[0m

       The following configuration variables are available:

       [4minfocard_sts_password[0m
           For managed InfoCards generated with a [34m[1mINFOCARD_STS_AUTH_TYPE[0m[1m[22m[3] of
           "passwd" and an [34m[1mINFOCARD_STS_PASSWORD_METHOD[0m[1m[22m[4] of "sts", this is
           the global user password that must be provided. Changing this
           password affects [4mall[24m managed InfoCard accounts.

[1mOPTIONS[0m

   [1mWeb Service Arguments[0m

       None.

[1mDIAGNOSTICS[0m

       The program exits 0 if everything was fine, 1 if an error occurred.

[1mBUGS[0m

       Secure token replay detection is not yet implemented.

       As this is a relatively new and complicated feature, please test
       carefully.

[1mSEE ALSO[0m

       [34m[1mdacsinfocard(1)[0m[1m[22m[5], [34m[1mdacs.conf(5)[0m[1m[22m[6], [34m[1mdacs_authenticate(8)[0m[1m[22m[7],
       [34m[1mdacs_infocard(8)[0m[1m[22m[8], [34m[1mdacs_managed_infocard(8)[0m[1m[22m[2], [34m[1mdacs_mex(8)[0m[1m[22m[9], [34m[1mUsing[0m
       [1m[34mInfoCards With DACS[0m[1m[22m[10]

[1mAUTHOR[0m

       Distributed Systems Software ([34m[1mwww.dss.ca[0m[1m[22m[11])

[1mCOPYING[0m

       Copyright © 2003-2025 Distributed Systems Software. See the [34m[1mLICENSE[0m[1m[22m[12]
       file that accompanies the distribution for licensing information.




[1mNOTES[0m

        1.
           dacsoptions
           http://dacs.dss.ca/man/dacs.1.html#dacsoptions

        2. dacs_managed_infocard(8)
           http://dacs.dss.ca/man/dacs_managed_infocard.8.html

        3. INFOCARD_STS_AUTH_TYPE
           http://dacs.dss.ca/man/dacs.conf.5.html#INFOCARD_STS_AUTH_TYPE

        4. INFOCARD_STS_PASSWORD_METHOD
           http://dacs.dss.ca/man/dacs.conf.5.html#INFOCARD_STS_PASSWORD_METHOD

        5. dacsinfocard(1)
           http://dacs.dss.ca/man/dacsinfocard.1.html

        6. dacs.conf(5)
           http://dacs.dss.ca/man/dacs.conf.5.html

        7. dacs_authenticate(8)
           http://dacs.dss.ca/man/dacs_authenticate.8.html

        8. dacs_infocard(8)
           http://dacs.dss.ca/man/dacs_infocard.8.html

        9. dacs_mex(8)
           http://dacs.dss.ca/man/dacs_mex.8.html

       10. Using InfoCards With DACS
           http://dacs.dss.ca/man/using‐infocards‐with‐dacs.html

       11. www.dss.ca
           https://www.dss.ca

       12. LICENSE
           http://dacs.dss.ca/man/../misc/LICENSE

DACS 1.5.0                        04/09/2025                       [4mDACS_STS[24m(8)
